unit QuaGlchg_U;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, Math;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    GroupBox1: TGroupBox;
    Label3: TLabel;
    Edit1: TEdit;
    Label4: TLabel;
    Edit2: TEdit;
    Label5: TLabel;
    Edit3: TEdit;
    GroupBox2: TGroupBox;
    Label7: TLabel;
    Edit4: TEdit;
    Label8: TLabel;
    Edit5: TEdit;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    Label6: TLabel;
    procedure BitBtn3Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.BitBtn3Click(Sender: TObject);
begin
  Close;
end;

procedure TForm1.BitBtn2Click(Sender: TObject);
begin
  Edit1.Clear;
  Edit2.Clear;
  Edit3.Clear;
  Edit4.Clear;
  Edit5.Clear;
  Label6.Visible := False;
  Label7.Visible := False;
  Label8.Visible := False;
  Edit4.Visible := False;
  Edit5.Visible := False;
  Edit1.SetFocus;
end;

procedure TForm1.BitBtn1Click(Sender: TObject);
var
  a, b, c: double;                     // Koeffizienten der qua. Glchg.
  x0, x1, x2: double;                  // Lsungen der Glchg.
  diskr: double;                       // Diskriminante
  d: double;                           // Wurzel der Diskriminante
begin
  a := StrToFloat(Edit1.Text);
  b := StrToFloat(Edit2.Text);
  c := StrToFloat(Edit3.Text);
  if a = 0 then
  begin
    if b = 0 then
    begin
      if c = 0 then
      begin
        Label6.Visible := True;
        Label6.Caption := 'Die Gleichung besitzt unendlich viele Lsungen!';
      end
      else begin
        Label6.Visible := True;
        Label6.Caption := 'Die Gleichung besitzt keine Lsungen!';
      end;{if c = 0}
    end
    else begin
      x0 := (- 1 * c)/b;
      Label6.Visible := True;
      Label6.Caption := 'Die Gleichung besitzt eine Lsung!';
      Label7.Visible := True;
      Edit4.Visible := True;
      Edit4.Text := FloatToStrF(x0,ffFixed,6,2);
    end; {if b = 0}
  end
  else begin
    diskr := Power(b,2) - 4*a*c;
    if diskr > 0 then
    begin
      d := SQRT(diskr);
      Label6.Visible := True;
      Label6.Caption := 'Die Gleichung hat 2 Lsungen!';
      Label7.Visible := True;
      Label8.Visible := True;
      Edit4.Visible := True;
      Edit5.Visible := True;
      x1 := (-1*b-d)/(2*a);
      x2 := (-1*b+d)/(2*a);
      Edit4.Text := FloatToStrF(x1,ffFixed,6,2);
      Edit5.Text := FloatToStrF(x2,ffFixed,6,2);
    end
    else begin
      if diskr = 0 then
      begin
        Label6.Visible := True;
        Label6.Caption := 'Die Gleichung hat eine Lsung!';
        Label7.Visible := True;
        Edit4.Visible := True;
        x0 := (-1*b)/(2*a);
        Edit4.Text := FloatToStrF(x0,ffFixed,6,2);
      end
      else begin
        Label6.Visible := True;
        Label6.Caption := 'Die Gleichung hat keine Lsung!';
      end;{if diskr = 0}
    end; {if diskr > 0}
  end; {if a = 0}
end;

end.